<template>
  <div class="item-list">
    <div class="item"
         v-for="item in items"
         :key="item.ident">
      <div class="image"><img :src="item.image" /></div>
      <div class="inner">
        <h4 class="title">{{item.title}}</h4>
        <p class="description">{{item.description}}</p>
        <p class="description">{{item.baseprice}}</p>
        <div class="price price--eur">
          <span class="amount">{{item.amount}}</span>
          <span class="value">{{formatPrice(item.price)}}</span>
          <span class="currency">€</span>
        </div>
        <div class="price price--kc">
          <span class="value">{{formatPrice(item.price*25, 0)}}</span>
          <span class="currency">kc</span>
        </div>
        <div class="info">
          <a :href="item.link" target="_blank"><img height="30" :src="getImage(item.origin)"></a>
        </div>
      </div>
    </div>
  </div>
</template>

<script>

export default {
  name: 'item',
  props: {
    items: {
      type: Array,
      default: () => []
    }
  },
  data () {
    return {
      placeholder: 'placeholder'
    }
  },
  methods: {
    formatPrice (value, decimal = 2) {
      let val = (value / 1).toFixed(decimal).replace('.', ',')
      return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, '.')
    },
    getImage (image) {
      return `${image}.png`
    }
  }
}
</script>

<style lang="postcss">
.item-list {
  padding: 24px;
  display: grid;
  grid-template-columns: 1fr 1fr 1fr 1fr 1fr;
  grid-gap: 32px;
  align-items: stretch;
  grid-auto-rows: minmax(250px, auto);
  transition-property: all;
  transition-duration: 1s;

  .item {
    display: flex;
    flex-direction: column;
    flex-wrap: nowrap;
    justify-content: flex-start;
    align-content: stretch;
    align-items: stretch;
    font-family: "Open Sans", sans-serif;
    box-sizing: border-box;
    background-color: rgb(255, 255, 255);
    overflow: hidden;

    .image {
      text-align: center;
      overflow: hidden;

      img {
        width: 100%;
        max-height: 140px;
      }
    }

    .inner {
      display: flex;
      flex-direction: column;
      flex-wrap: nowrap;
      justify-content: flex-start;
      align-content: stretch;
      align-items: stretch;
      flex: 1 1 auto;
      box-sizing: border-box;
      padding: 12px;
    }

    .title {
      display: block;
      color: #333;
      font-size: 1.3rem;
      font-weight: 600;
      line-height: 1;
      margin: 0;
    }

    .description {
      flex: 1 1 auto;
      color: #555;
    }

    .price {
      display: flex;
      flex-direction: row;
      flex-wrap: nowrap;
      justify-content: flex-start;
      align-content: stretch;
      align-items: flex-end;
      font-size: 2rem;
      color: #444;

      .amount {
        flex: 0 1 auto;
        font-size: 0.4em;
        vertical-align: bottom;
      }

      .value {
        flex: 1 1 auto;
        text-align: right;
        font-weight: 600;
      }

      .currency {
        flex: 0 1 auto;
        width: 20px;
        padding-left: 6px;
        font-size: 0.6em;
      }

      &--eur {
        .value {
          margin-bottom: -.2em;
        }
      }

      &--kc {
        font-size: 1.2em;

        .currency {
          font-size: 0.8em;
        }
      }
    }
  }
}

@media only screen and (max-width: 2450px) {
  .item-list {
    grid-template-columns: 1fr 1fr 1fr 1fr 1fr 1fr;
  }
}

@media only screen and (max-width: 2100px) {
  .item-list {
    grid-template-columns: 1fr 1fr 1fr 1fr 1fr;
  }
}

@media only screen and (max-width: 1200px) {
  .item-list {
    grid-template-columns: 1fr 1fr 1fr 1fr;
  }
}

@media only screen and (max-width: 950px) {
  .item-list {
    grid-template-columns: 1fr 1fr 1fr 1fr;
  }
}

@media only screen and (max-width: 900px) {
  .item-list {
    grid-template-columns: 1fr 1fr 1fr;
  }
}

@media only screen and (max-width: 600px) {
  .item-list {
    grid-template-columns: 1fr 1fr;
  }
}

@media only screen and (max-width: 450px) {
  .item-list {
    grid-template-columns: 1fr;
  }
}
</style>
